//-----------------------------------------------------------------
//FLASH96K Controller Register Interface testbench.
//-----------------------------------------------------------------

`timescale 1ns / 1ps

module tb;

reg clk ;
reg rstn;

reg read;
reg clear_page_lacth;
reg write_page_latch;
reg erase;
reg pre_prog;
reg prog;
reg [31:0] flash_datain;
reg [5:0] page_address;
reg [8:0]row_address;
reg [5:0]colu_address;

wire done_sig;

integer num;

initial
begin
  clk =0;
  forever
  begin
    #10 clk   =       ~clk;
  end
end

initial 
begin
  row_address  = 9'b0;
  colu_address = 6'b0;
  page_address = 6'b0;
  flash_datain  = 32'b0;
  erase = 1'b0;
  prog  = 1'b0;
  write_page_latch = 1'b0;
  clear_page_lacth = 1'b0;
  pre_prog = 1'b0;
  rstn = 1'b1;
  #10 rstn = 1'b0;
  read = 1'b0;
  #100000  rstn = 1'b1;
  
  page_address = num;

  //write opreation
  #100 clear_page_lacth = 1'b1;
  #100 clear_page_lacth = 1'b0;
  wait      (done_sig == 1'b1);

  for(num = 0; num <= 'h2F ; num ++)
  begin
    page_address = num;

    #100 flash_datain = 32'hf0000000 + num;
    #100 write_page_latch = 1'b1;
    #100 write_page_latch = 1'b0;
    wait      (done_sig == 1'b1);
  end

  #100       pre_prog = 1'b1;
  #100       pre_prog = 1'b0;
  wait      (done_sig == 1'b1);

  #100      erase            = 1'b1;
  #100      erase            = 1'b0;
  wait      (done_sig == 1'b1);

  #100      prog  = 1'b1;
  #100      prog  = 1'b0;
  wait      (done_sig == 1'b1);

  for(num = 0; num <= 'h2F ; num ++)
  begin
    row_address  = 9'b0;
    colu_address = num;

    #100      read = 1'b1; 
    #100      read = 1'b0;
    wait      (done_sig == 1'b1);
  end

  #5000000;
  $finish;
end

Gowin_Flash_Controller_Top u_Gowin_Flash_Controller_Top
(
  .clk_i                 (clk),//50MHZ
  .nrst_i                (rstn),
  .r_en_i                (read),
  .clear_page_enable_i   (clear_page_lacth),
  .prog_enable_i         (prog),
  .write_page_enable_i   (write_page_latch),
  .erase_en_i            (erase),
  .pre_prog_i            (pre_prog),

  .wyaddr_i              (row_address),
  .wxaddr_i              (colu_address),
  .page_address          (page_address),
  .wdata_i               (flash_datain),
  .rdata_o               (),
  .done_flag_o           (done_sig) 
);

initial
begin
  $fsdbDumpfile("Gowin_Flash_Controller.fsdb");
  $fsdbDumpvars;
end
   
endmodule
